#pragma semicolon 1

#include <sourcemod>
#include <sdktools_stringtables>

public Plugin:myinfo = 
{
	name	= "Add To Download",
	author	= "wS",
	version	= "1.2.3"
};

public OnMapStart()
{
	new Handle:hFile = OpenFile("cfg/add_to_download.txt", "rt");
	if (hFile == INVALID_HANDLE) { return; }
	decl String:sEntry[PLATFORM_MAX_PATH];
	new length;
	while (!IsEndOfFile(hFile) && ReadFileLine(hFile, sEntry, sizeof(sEntry)))
	{
		if ((length = TrimString(sEntry)) && sEntry[0] != '/')
		{
			ReplaceString(sEntry, sizeof(sEntry), "\\", "/", true);
			if (DirExists(sEntry))
			{
				if (sEntry[length-1] == '/') { sEntry[length-1] = 0; }
				LoadFromDir(sEntry);
			}
			else if (ExtAllowed(sEntry, length)) {
				AddFileToDownloadsTable(sEntry);
			}
		}
	}
	CloseHandle(hFile);
}

LoadFromDir(const String:sDir[])
{
	new Handle:hDir = OpenDirectory(sDir);
	if (hDir != INVALID_HANDLE)
	{
		decl String:sEntry[128], String:sPath[PLATFORM_MAX_PATH], FileType:t;
		while (ReadDirEntry(hDir, sEntry, sizeof(sEntry), t))
		{
			if (t == FileType_File && ExtAllowed(sEntry, strlen(sEntry)))
			{
				FormatEx(sPath, sizeof(sPath), "%s/%s", sDir, sEntry);
				AddFileToDownloadsTable(sPath);
			}
			else if (t == FileType_Directory && strcmp(sEntry, ".", true) && strcmp(sEntry, "..", true))
			{
				FormatEx(sPath, sizeof(sPath), "%s/%s", sDir, sEntry);
				LoadFromDir(sPath);
			}
		}
		CloseHandle(hDir);
	}
}

bool:ExtAllowed(const String:s[], length)
{
	new i = length;
	while (--i > -1)
	{
		if (s[i] == '.') {
			return i > 0 && ((i+1) != length) && strcmp(s[i+1], "ztmp", false) && strcmp(s[i+1], "bz2", false);
		}
	}
	return false;
}